Index: stable/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj
===================================================================
--- stable/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj	(revision 10795)
+++ stable/HeuristicLab.Collections/3.3/HeuristicLab.Collections-3.3.csproj	(revision 10864)
@@ -157,4 +157,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
       <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
Index: stable/HeuristicLab.Collections/3.3/ObservableArray.cs
===================================================================
--- stable/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 10795)
+++ stable/HeuristicLab.Collections/3.3/ObservableArray.cs	(revision 10864)
@@ -25,4 +25,5 @@
 using System.ComponentModel;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -168,5 +169,5 @@
         Array.Clear(array, index, length);
         OnPropertyChanged("Item[]");
-        OnItemsReplaced(GetIndexedItems(index, length), oldItems); 
+        OnItemsReplaced(GetIndexedItems(index, length), oldItems);
       }
     }
@@ -205,5 +206,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array);
+        array.StableSort();
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -213,5 +214,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array, comparison);
+        array.StableSort(comparison);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -221,5 +222,5 @@
       if (array.Length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        Array.Sort<T>(array, comparer);
+        array.StableSort(comparer);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(), oldItems);
@@ -229,5 +230,5 @@
       if (length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, length);
-        Array.Sort<T>(array, index, length);
+        array.StableSort(index, length);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(index, length), oldItems);
@@ -237,5 +238,5 @@
       if (length > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, length);
-        Array.Sort<T>(array, index, length, comparer);
+        array.StableSort(index, length, comparer);
         OnPropertyChanged("Item[]");
         OnItemsMoved(GetIndexedItems(index, length), oldItems);
Index: stable/HeuristicLab.Collections/3.3/ObservableList.cs
===================================================================
--- stable/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 10795)
+++ stable/HeuristicLab.Collections/3.3/ObservableList.cs	(revision 10864)
@@ -25,4 +25,5 @@
 using System.ComponentModel;
 using System.Linq;
+using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -320,5 +321,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort();
+        list.StableSort();
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -328,5 +329,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort(comparison);
+        list.StableSort(comparison);
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -336,5 +337,5 @@
       if (list.Count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems();
-        list.Sort(comparer);
+        list.StableSort(comparer);
         OnItemsMoved(GetIndexedItems(), oldItems);
         OnPropertyChanged("Item[]");
@@ -344,5 +345,5 @@
       if (count > 1) {
         IndexedItem<T>[] oldItems = GetIndexedItems(index, count);
-        list.Sort(index, count, comparer);
+        list.StableSort(index, count, comparer);
         OnItemsMoved(GetIndexedItems(index, count), oldItems);
         OnPropertyChanged("Item[]");
Index: stable/HeuristicLab.Collections/3.3/Plugin.cs.frame
===================================================================
--- stable/HeuristicLab.Collections/3.3/Plugin.cs.frame	(revision 10795)
+++ stable/HeuristicLab.Collections/3.3/Plugin.cs.frame	(revision 10864)
@@ -29,4 +29,5 @@
   [PluginFile("HeuristicLab.Collections-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
   public class HeuristicLabCollectionsPlugin : PluginBase {
   }
Index: stable/HeuristicLab.Common/3.3/ArrayExtensions.cs
===================================================================
--- stable/HeuristicLab.Common/3.3/ArrayExtensions.cs	(revision 10864)
+++ stable/HeuristicLab.Common/3.3/ArrayExtensions.cs	(revision 10864)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Common {
+  public static class ArrayExtensions {
+
+    public static void StableSort<T>(this T[] values, Comparison<T> comparison) {
+      values.StableSort(new StableSortComparer<T>(comparison));
+    }
+
+    public static void StableSort<T>(this T[] values, IComparer<T> comparer = null) {
+      var sorted = values.OrderBy(x => x, comparer ?? Comparer<T>.Default).ToArray();
+      Array.ConstrainedCopy(sorted, 0, values, 0, values.Length);
+    }
+
+    public static void StableSort<T>(this T[] values, int index, int length, Comparison<T> comparison) {
+      values.StableSort(index, length, new StableSortComparer<T>(comparison));
+    }
+
+    public static void StableSort<T>(this T[] values, int index, int length, IComparer<T> comparer = null) {
+      if (index < 0) throw new ArgumentOutOfRangeException("index is less than zero.");
+      if (length < 0) throw new ArgumentOutOfRangeException("length is less than zero.");
+      if (index + length > values.Length) throw new ArgumentException("index and length do not specify a valid range in the array.");
+      var sortedArray = values.Skip(index).Take(length).OrderBy(x => x, comparer ?? Comparer<T>.Default).ToArray();
+      Array.ConstrainedCopy(sortedArray, 0, values, index, length);
+    }
+
+    private class StableSortComparer<T> : IComparer<T> {
+      public StableSortComparer(Comparison<T> comparison) {
+        this.comparison = comparison;
+      }
+      public int Compare(T x, T y) {
+        return comparison(x, y);
+      }
+      private readonly Comparison<T> comparison;
+    }
+  }
+}
Index: stable/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj
===================================================================
--- stable/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj	(revision 10795)
+++ stable/HeuristicLab.Common/3.3/HeuristicLab.Common-3.3.csproj	(revision 10864)
@@ -124,4 +124,6 @@
     <Compile Include="Content\IStorableContent.cs" />
     <Compile Include="Constants.cs" />
+    <Compile Include="ArrayExtensions.cs" />
+    <Compile Include="ListExtensions.cs" />
     <Compile Include="Point2D.cs" />
     <Compile Include="EnumerableExtensions.cs" />
Index: stable/HeuristicLab.Common/3.3/ListExtensions.cs
===================================================================
--- stable/HeuristicLab.Common/3.3/ListExtensions.cs	(revision 10864)
+++ stable/HeuristicLab.Common/3.3/ListExtensions.cs	(revision 10864)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Common {
+  public static class ListExtensions {
+
+    public static void StableSort<T>(this List<T> values, Comparison<T> comparison) {
+      values.StableSort(new StableSortComparer<T>(comparison));
+    }
+
+    public static void StableSort<T>(this List<T> values, IComparer<T> comparer = null) {
+      int i = 0;
+      foreach (var e in values.OrderBy(x => x, comparer ?? Comparer<T>.Default))
+        values[i++] = e;
+    }
+
+    public static void StableSort<T>(this List<T> values, int index, int count, Comparison<T> comparison) {
+      values.StableSort(index, count, new StableSortComparer<T>(comparison));
+    }
+
+    public static void StableSort<T>(this List<T> values, int index, int count, IComparer<T> comparer = null) {
+      if (index < 0) throw new ArgumentOutOfRangeException("index is less than zero.");
+      if (count < 0) throw new ArgumentOutOfRangeException("count is less than zero.");
+      if (index + count > values.Count) throw new ArgumentException("index and count do not specify a valid range in the List<T>.");
+      var orderedList = values.Skip(index).Take(count).OrderBy(x => x, comparer ?? Comparer<T>.Default);
+      int i = index;
+      foreach (var e in orderedList)
+        values[i++] = e;
+    }
+
+    private class StableSortComparer<T> : IComparer<T> {
+      public StableSortComparer(Comparison<T> comparison) {
+        this.comparison = comparison;
+      }
+      public int Compare(T x, T y) {
+        return comparison(x, y);
+      }
+      private readonly Comparison<T> comparison;
+    }
+  }
+}
Index: stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 10795)
+++ stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 10864)
@@ -841,7 +841,7 @@
       ts.SetSeedRandomly.Value = false;
       RunAlgorithm(ts);
-      Assert.AreEqual(6441, GetDoubleResult(ts, "BestQuality"));
-      Assert.AreEqual(7401.666666666667, GetDoubleResult(ts, "CurrentAverageQuality"));
-      Assert.AreEqual(8418, GetDoubleResult(ts, "CurrentWorstQuality"));
+      Assert.AreEqual(6294, GetDoubleResult(ts, "BestQuality"));
+      Assert.AreEqual(7380.0386666666664, GetDoubleResult(ts, "CurrentAverageQuality"));
+      Assert.AreEqual(8328, GetDoubleResult(ts, "CurrentWorstQuality"));
       Assert.AreEqual(750000, GetIntResult(ts, "EvaluatedMoves"));
     }
@@ -912,8 +912,8 @@
       vrp.SetSeedRandomly.Value = false;
       RunAlgorithm(vrp);
-      Assert.AreEqual(1436, GetDoubleResult(vrp, "BestQuality"));
-      Assert.AreEqual(2132.2478893442621, GetDoubleResult(vrp, "CurrentAverageQuality"));
-      Assert.AreEqual(4176.0, GetDoubleResult(vrp, "CurrentWorstQuality"));
-      Assert.AreEqual(119011, GetIntResult(vrp, "EvaluatedMoves"));
+      Assert.AreEqual(1473, GetDoubleResult(vrp, "BestQuality"));
+      Assert.AreEqual(2102.1192622950812, GetDoubleResult(vrp, "CurrentAverageQuality"));
+      Assert.AreEqual(4006, GetDoubleResult(vrp, "CurrentWorstQuality"));
+      Assert.AreEqual(119072, GetIntResult(vrp, "EvaluatedMoves"));
     }
 
Index: stable/HeuristicLab.Tests/TestRandom.cs
===================================================================
--- stable/HeuristicLab.Tests/TestRandom.cs	(revision 10795)
+++ stable/HeuristicLab.Tests/TestRandom.cs	(revision 10864)
@@ -61,7 +61,7 @@
 
     public TestRandom(int[] intNumbers, double[] doubleNumbers) {
-      if (intNumbers == null) intNumbers = new int[0];
+      if (intNumbers == null) this.intNumbers = new int[0];
       else this.intNumbers = intNumbers;
-      if (doubleNumbers == null) doubleNumbers = new double[0];
+      if (doubleNumbers == null) this.doubleNumbers = new double[0];
       else this.doubleNumbers = doubleNumbers;
       nextIntIndex = 0;